Subject: Re: Network optimality (was Re: [PATCH net-next] qdisc: validate skb without holding lock_

From: Jesper Dangaard Brouer <[email-masked]>
Date: Mon, 13 Oct 2014 22:27:17 +0200

On Mon, 13 Oct 2014 10:20:17 -0700 Dave Taht <[email-masked]> wrote:

> On Mon, Oct 13, 2014 at 9:58 AM, Eric Dumazet <[email-masked]> wrote:
> >
> >> On Oct 13, 2014 7:22 AM, "Dave Taht" <[email-masked]> wrote:
[...]
> 
> I would like to also get better behavior out of gigE and below, and for
> these changes to not impact the downstream behavior of the network
> overall.

I also care about 1Gbit/s and below, that why I did some many tests
(with igb at 10Mbit/s, 100Mbit/s and 1Gbit/s).  

> To give you an example, I would like to see the tcp flows in the
> 2nd chart here, to converge faster than the 5 seconds they currently
> take at GigE speeds.
> 
> http://snapon.lab.bufferbloat.net/~cero2/nuc-to-puck/results.html

In the last graph, where you cannot saturate the link, because you
turned off GSO, GRO and TSO.  Here I expect you will see the benefit of
the qdisc bulking. That is, will be able to saturate the link and
achieve the lower latency as BQL will cut off the bursts at +1 MTU.
I would be interested in the results...

> > We made all these changes so that we can spend cpu cycles at the right
> > place.

Exactly. 

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Sr. Network Kernel Developer at Red Hat
  Author of http://www.iptv-analyzer.org
  LinkedIn: http://www.linkedin.com/in/brouer